		AREA	IRQ_setup, CODE, READWRITE
		EXTERN 	NXTPROC
		EXTERN	TIMERBASE
		EXPORT	INITIRQ
		;install interrupt handler

INITIRQ
		MOV		r1, #0x18
		ADR		r0, IRQ
		SUB		r0, r0, #0x18+8   		;pc relative branch distance from IRQ vector
		AND		r0, r0, #0x03ffffff
		MOV		r0, r0, lsr #2
		ORR		r0, r0, #0xea000000		;build branch instruction to handler
		STR 	r0, [r1]
		MOV		pc, lr

		;handler counts number of IRQs (caused by timer)
		;and calls nxtproc every IRQCNT interrupts

IRQ		LDR		r13, IRQCNT				;r13=count
		SUBS	r13, r13, #1			;count--
		LDREQ	r13, IRQRST				;if(!count) reset count	
		STR		r13, IRQCNT				;store count
		LDR		r12, =TIMERBASE			;r13->timer ctrl register
		STR		r12, [r12,#0xc]			;reset timer/clear interrupt source
		
		BEQ		NXTPROC					;process switch
		SUBS	pc, lr, #4				;return from interrupt


IRQCNT	DCD	0x80						;current count value
IRQRST	DCD	0x80						;reset value

		END